> For the complete documentation index, see [llms.txt](https://docs.trymito.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.trymito.io/mito-for-dash/common-design-patterns/graph-new-data-after-edits-to-mito.md).

# Graph New Data after Edits to Mito

## Motivation

1. A user is filtering a dataset using a Mito sheet.
2. You want to update a graph of this data elsewhere in your dashboard.

## How to:

Simply use the `@mito_callback`  to watch for changes on the `spreadsheet_result` prop, and then graph the resulting dataframe.

<pre class="language-python"><code class="lang-python">from dash import Dash, html, dcc, Output, Input
<strong>from dash.exceptions import PreventUpdate
</strong>import plotly.express as px
import pandas as pd

from mitosheet.mito_dash.v1 import Spreadsheet, mito_callback, activate_mito

df = pd.read_csv('https://raw.githubusercontent.com/plotly/datasets/master/gapminder_unfiltered.csv')

app = Dash(__name__)
activate_mito(app)

app.layout = html.Div([
    Spreadsheet(df, id={'type': 'spreadsheet', 'id': 'sheet'}),
    dcc.Graph(id='graph-content'),
])

@mito_callback(
    Output('graph-content', 'figure'),
    Input({'type': 'spreadsheet', 'id': 'sheet'}, 'spreadsheet_result')
)
def update_code(spreadsheet_result):
    if spreadsheet_result is None:
        raise PreventUpdate

    # Get the current value of the original dataframe
    dff = spreadsheet_result.dfs()[0]
    
    # Requires that the user doesn't delete the year, lifeExp, or continent column
    return px.line(dff, x='year', y='lifeExp', color='continent')

if __name__ == '__main__':
    app.run(debug=True)
</code></pre>

Now, if the user filters the original data in any way, the new data will be displayed on the page.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.trymito.io/mito-for-dash/common-design-patterns/graph-new-data-after-edits-to-mito.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
